package cn.iocoder.yudao.module.pms.service.iotmaterial;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.pms.controller.admin.iotmaterial.vo.IotMaterialPageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.iotmaterial.vo.IotMaterialSaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.iotmaterial.IotMaterialDO;

import javax.validation.Valid;
import java.util.List;

/**
 * PMS 功能优化 物料 Service 接口
 *
 * @author 芋道源码
 */
public interface IotMaterialService {

    /**
     * 创建PMS 功能优化 物料
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createIotMaterial(@Valid IotMaterialSaveReqVO createReqVO);

    /**
     * 更新PMS 功能优化 物料
     *
     * @param updateReqVO 更新信息
     */
    void updateIotMaterial(@Valid IotMaterialSaveReqVO updateReqVO);

    /**
     * 修改状态
     *
     * @param id     物料id
     * @param status 状态
     */
    void updateMaterialStatus(Long id, Integer status);

    /**
     * 删除PMS 功能优化 物料
     *
     * @param id 编号
     */
    void deleteIotMaterial(Long id);

    /**
     * 获得PMS 功能优化 物料
     *
     * @param id 编号
     * @return PMS 功能优化 物料
     */
    IotMaterialDO getIotMaterial(Long id);

    /**
     * 获得PMS 功能优化 物料分页
     *
     * @param pageReqVO 分页查询
     * @return PMS 功能优化 物料分页
     */
    PageResult<IotMaterialDO> getIotMaterialPage(IotMaterialPageReqVO pageReqVO);

    /**
     * 获得PMS 功能优化 物料 列表
     *
     * @param pageReqVO 分页查询
     * @return PMS 功能优化 物料 列表
     */
    List<IotMaterialDO> getIotMaterials(IotMaterialPageReqVO pageReqVO);

    /**
     * 获得指定状态的 物料
     *
     * @param status 状态
     * @return 物料列表
     */
    List<IotMaterialDO> getMaterialListByStatus(Integer status);

    /**
     * 根据设备分类bom节点id获取物料列表
     *
     * @param reqVO bom节点id
     * @return 物料列表
     */
    PageResult<IotMaterialDO> getMaterialsByBomId(IotMaterialPageReqVO reqVO);

    /**
     * 根据设备bom节点id获取物料列表
     *
     * @param reqVO bom节点id
     * @return 物料列表
     */
    PageResult<IotMaterialDO> getMaterialsByDeviceBomId(IotMaterialPageReqVO reqVO);

    /**
     * 查询物料表中最大的id
     *
     * @return 最大的工单id
     */
    Long theMaxId();
}